;-------------------------------
; echo #17. 
; crack intro.
; wackee/arise.
; 
; written in relaunch64 v2.1b3.
; for compiling with TMPx v1.0.
; 3o/11/2o13.
;------------------------------
;
; memory layout:
;
; 0800 - 1000 code
; 1000 - 1e00 music
; 1e00 - 2000 scroll font
; 2000 - 2200 layout charset
; 2200 - 2300 chars for scrolling (1)
; 2300 - 2400 chars for scrolling (2) 
; 2400 - 2600 charset for animation
; 2600 - 2800 (free) 
; 2800 - 2c00 screen
; 2c00 - 3000 anim.sc1
; 3000 - 3400 anim.sc2
; 3400 - 3800 anim.sc3
; 3800 - 3c00 anim.sc4
; 3c00 - 4000 anim.sc5
; 4000 - 4400 scrolltext
;-------------------------------

;-------------------------------
; basic line
;-------------------------------

			* = $0801
			
			.byte      $0b, $08, $01, $00, $9e, $32, $30
			.byte $36, $36, $00

;-------------------------------
; inits
;-------------------------------

			* = $0812
			
			sei
			lda #$35
			sta $01			
			;
			; wait for it
			;
			ldy #$20
			jsr wait

			; 
			; music init
			;
			lda #$00
			jsr init_msx
			
			;
			; setup irq
			;
			lda #$7f
			sta $dc0d
			sta $dd0d
			;
			lda $dc0d
			lda $dd0d
			;
			lda #$01
			sta $d01a
			lda #$80
			sta $d012
			lda $d011
			and #$7f
			sta $d011
			;
			lda #<irq
			sta $fffe
			lda #>irq
			sta $ffff
			
			;
			; let the music play
			;
			cli
			
			; 
			; #$ff fill for upscroll chars
			;
			ldx #$00
			lda #$ff
two56fill		sta $2200,x
			sta $2300,x
			inx
			bne two56fill

			;
			; add first scroll chars to screen layout
			;
			lda #$40
			ldx #25
scr_chr_address	sta $2808
			tay
			lda scr_chr_address+1
			clc
			adc #$28
			sta scr_chr_address+1
			bcc next_column
			inc scr_chr_address+2									
next_column	iny
			tya
			dex
			bne scr_chr_address

			;
			; add second scroll chars to screen layout
			;
			lda #$60
			ldx #20
scr_chr_address2	sta $28d5
			tay
			lda scr_chr_address2+1
			clc
			adc #$28
			sta scr_chr_address2+1
			bcc next_column2
			inc scr_chr_address2+2									
next_column2	iny
			tya
			dex
			bne scr_chr_address2

			;
			; +80'ing of the anim screens
			; (charset starting at 2400 instead of 2000)
			;
loop_80ing		ldx #$00
			;			
address_80ing1	lda $2c00,x
			clc
			adc #$80
address_80ing2	sta $2c00,x
			;
			inx
			bne address_80ing1
			;
			inc address_80ing1+2
			inc address_80ing2+2
			lda address_80ing1+2
			cmp #$40
			bne loop_80ing	
			
;-------------------------------------
; fade in
;-------------------------------------

			;
			; wait for it
			;
			ldy #$40
			jsr wait
			;
			; fade out chars + border
			;
			ldx #$00
			;
fadechar		ldy #$03
			jsr wait
			;
			lda fadecol_chars,x
			sta $d020
			;
			ldy #$00
fade_charloop1	sta $d800,y
			sta $d900,y
			sta $da00,y
			sta $db00,y
			iny
			bne fade_charloop1
			;
			inx
			cpx #$04
			bne fadechar
			;
			; clear screen
			; char color to white
			;
			ldx #$00
clear0400		lda #$20
			sta $0400,x
			sta $0500,x
			sta $0600,x
			sta $0700,x
			lda #$01
			sta $d800,x
			sta $d900,x
			sta $da00,x
			sta $db00,x
			inx
			bne clear0400
			;
			; wait for it
			;
			ldy #$40
			jsr wait
			;
			; fade d020/d021
			;
			ldx #$00
			;
fadescreen		ldy #$02
			jsr wait
			;
			lda fadecol_d020,x
			sta $d020
			lda fadecol_d021,x
			sta $d021
			;
			inx
			cpx #$0c
			bne fadescreen
			; 
			; wait for it
			;
			ldy #$40
			jsr wait
			; 
			; setup vic (carefully...)
			;
			lda $dd00
			and #$fc
			ora #$03		; bank0
			sta $dd00
			;
			lda $d018
			and #$01
			ora #%00010100	; chars @ 1000, screen @ 0400
			sta $d018		
			;
			; let's animate!
			;
			ldx #$00
			;	
animate		ldy #$03
			jsr wait
			;			
			lda anim_pointer,x
			sta address_frame+1
			;
			lda $d018
			and #$01
address_frame	ora #$00
			sta $d018
			;
			inx
			cpx #$05
			bne animate
			;
			; wait for it
			;			
			ldy #$03
			jsr wait
			;
			; layout screen setup 
			;
			lda $d018
			and #$01
			ora #%10101000
			sta $d018
			; 
			; blank the faces
			;
			lda #$00
			jsr color_face1
			;
			lda #$02
			jsr color_face2
			;
			; setup sprites
			;
			lda #$0f		; s0-3 = on
			sta $d015
			;
			lda #$63		; s0-3 x
			sta $d000
			sta $d002
			sta $d004
			sta $d006			
			;
			lda #$5a		; s0-3 y
			sta $d001
			lda #$84
			sta $d003
			lda #$ae
			sta $d005
			lda #$d8
			sta $d007
			;
			lda #$02		; s0-3 = red
			sta $d027
			sta $d028
			sta $d029
			sta $d02a
			;
			lda #$00		; s0-3 = hires
			sta $d01c
			;
			lda #$0f		; s0-3 y = stretched
			sta $d017
			;
			lda #$0f		; s0-3 x = stretched
			sta $d01d
			;
			lda #$8f		; s0-3 shape
			sta $2bf8
			sta $2bf9
			sta $2bfa
			sta $2bfb
			;
			lda #$0f		; s0-3 priority = low
			sta $d01b
			;
			; fade in the faces
			;
			ldy #$40
			jsr wait
			;
			ldx fadein_facex
			;
fadein_faces	ldy #$02
			jsr wait
			;
			lda fadecol_face1,x
			jsr color_face1
			;
			ldx fadein_facex
			;
			lda fadecol_face2,x
			jsr color_face2
			;
			ldx fadein_facex
			inx
			stx fadein_facex
			cpx #$0c
			bne fadein_faces
			;

;-------------------------------------
; main loop
;--------------------------------------

			; 
			; everything's set up!
			; let's start the show
			;
main_loop		ldy #$01
			jsr wait
			;
			; are we fading out?
			;
			lda fadeout_flag
			cmp #$00
			beq no_fadeout
			;
			; we do the fadeout
			;
			jsr fadeout
			;
			; is the fadeout finished?
			;
			lda fadeout_flag
			cmp #$01
			beq no_fadeout
			;
			; fadeout finished, exit stage left
			;
			jmp exit
			;
			; is the space pressed?
			;
no_fadeout		lda $dc01
			cmp #$ef
			bne no_space_press	
			;
			; space pressed, let's fadeout next time we're here
			;
			lda #$01
			sta fadeout_flag
			
no_space_press	;	
			;
			;
czy_scroll1	lda scroll1_frame
			cmp #$00
			bne czy_scroll2
			;
			; do the first scroll
			;
			jsr scroll_up
			jsr do_scroll1
			;
czy_scroll2	lda scroll2_frame
			cmp #$00
			bne inc_counter1
			;
			; do the second scroll
			;			
			jsr scroll2_up
			jsr do_scroll2
			;
			
inc_counter1	inc scroll1_frame
			lda scroll1_frame
			cmp #$02
			bne inc_counter2
			lda #$00
			sta scroll1_frame
			;
inc_counter2	inc scroll2_frame
			lda scroll2_frame
			cmp #$04
			bne main_loop
			lda #$00
			sta scroll2_frame
			;
			; loop that
			;
			jmp main_loop	
			
			;
			; exit stuff
			;
exit			; setup 'normal' screen
			;
			ldy #$01
			jsr wait
			;			
			lda $d018
			and #$01
			ora #%00010100	; chars @ 1000, screen @ 0400
			sta $d018
			;
			; sprites off
			;
			lda #$00
			sta $d015
			;
			; wait for it
			;
			ldy #$20
			jsr wait		
			;
			; throw the credits on the screen
			;
			ldx #$27
creds_txt_out	lda credits,x
			sta $07c0,x
			dex
			cpx #$ff
			bne creds_txt_out
			;
			; fade out the d021 to show the credits
			;
			ldx #$09
			;
show_creds		ldy #$02
			jsr wait
			;
			lda fadecol_face1,x
			sta $d020
			sta $d021
			;
			dex
			cpx #$ff
			bne show_creds
			; 
			; fade out the music 
			;
volume_loop	ldy #$10
			jsr wait
			;
			lda volume
			sta address_volume+1
			;
			lda $101b	; volume for gmc
			and #$f0
address_volume	ora #$00
			sta $101b
			;
			dec volume
			lda volume
			cmp #$ff
			bne volume_loop 
			;
			; fade the credits out
			;
fade_credits	ldy #$02
			jsr wait
			;
			ldx fadeout_credits
			lda fadecol_out_d021,x
			;
			ldx #$00
fill_last_line	sta $dbc0,x
			inx
			cpx #$28
			bne fill_last_line
			;
			dec fadeout_credits
			lda fadeout_credits
			cmp #$ff
			bne fade_credits
			;
			; clean the last line
			;
			lda #$20
			ldx #$00
clean_last_line	sta $07c0,x
			inx
			cpx #$28
			bne clean_last_line
			;
			; wait for it
			;			
			ldy #$10
			jsr wait
			;
			; reset 
			;
end_complete	sei
			lda #$37
			sta $01
			jmp $fce2			
			
;-------------------------------
; irq 
;-------------------------------

irq			sta aa+1
			stx xx+1
			sty yy+1
			;
			jsr play_msx
			;
			lsr $d019
			;
aa			lda #$00
xx			ldx #$00
yy			ldy #$00
			;
			rti

;-------------------------------
; variables, counters, flag-holders etc.
;-------------------------------

init_msx	= $18ea
play_msx	= $14ea

current_line	.byte $00
current_char	.byte $00

scroll1_frame	.byte $00
scroll2_frame	.byte $00

scroll1_char	.byte $00
shrink_char	.byte $00

background		.byte $01
column1_color	.byte $00
column2_color	.byte $02

fadein_facex	.byte $00

fadeout_flag	.byte $00	; 0 = no, 1 = yes, 2 = done, go out
fadeout_counter	.byte $00
fadeout_frames	.byte $00

fadeout_credits	.byte $08

volume		.byte $0f

;---------------------------------
; tables
;---------------------------------

			;
			; fade in color tables
			;
fadecol_chars	.byte $0e, $04, $0b, $06
			;
fadecol_d020	.byte $06, $06, $06, $06, $06, $0b, $04, $0e, $05, $03, $0d, $01
fadecol_d021	.byte $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $00
			;
fadecol_face1	.byte $00, $09, $0b, $08, $0c, $0a, $0f, $07, $01, $01, $01, $01
fadecol_face2	.byte $02, $02, $02, $02, $02, $02, $08, $0c, $0a, $0f, $07, $01	

			; 
			; anim framepointers
			; charset @ 2000
			;
anim_pointer	.byte %10111000	; 1 / 2c00
			.byte %11001000	; 2 / 3000
			.byte %11011000	; 3 / 3400
			.byte %11101000	; 4 / 3800
			.byte %11111000	; 5 / 3c00

			;
			; colors for fadeout
			;
fadecol_out_d021	.byte $00, $09, $02, $08, $0c, $0a, $0f, $07, $01
fadecol_out_spr	.byte $02, $02, $02, $08, $0c, $0a, $0f, $07, $01

;-------------------------------
; procedures
;-------------------------------
			
			;
			; classic wait routine
			; y = amount of frames
			;
wait			bit $d011
			bpl *-3
			bit $d011
			bmi *-3
			dey
			bne wait
			rts
;-------------------------------

			;
			; first scroll up
			;
scroll_up		ldx #$00
			;
scroll_up_loop	lda $2201,x
			sta $2200,x
			inx
			cpx #$c7
			bne scroll_up_loop
			rts
;-------------------------------

			;
			; second scroll2 up
			;
scroll2_up		ldx #$00
			;
scroll2_up_loop	lda $2301,x
			sta $2300,x
			inx
			cpx #$9f
			bne scroll2_up_loop
			rts
;-------------------------------		

			;
			; color the first face
			;
color_face1	ldx #$03
			;
color_face1_loop	sta $d800+ 40,x 	; line 2
			sta $d800+ 80,x 	; line 3
			sta $d800+120,x 	; line 4
			sta $d800+160,x 	; line 5
			sta $d800+200,x	; line 6
			sta $d800+240,x	; line 7
			sta $d800+280,x	; line 8
			sta $d800+320,x	; line 9
			sta $d800+360,x	; line 10
			sta $d800+400,x	; line 11
			;
			inx
			cpx #$08
			bne color_face1_loop
			;
			rts				
;-------------------------------
	
			; 
			; color the second face
			;
color_face2	ldx #$0a
			;
color_face2_loop	sta $d800+200,x	; line 6
			sta $d800+240,x	; line 7
			sta $d800+280,x	; line 8
			sta $d800+320,x	; line 9
			sta $d800+360,x	; line 10
			sta $d800+400,x	; line 11
			sta $d800+440,x	; line 12
			;
			inx
			cpx #$0d
			bne color_face2_loop
			;
			rts
;-------------------------------

			;
			; do the first scroll
			;
do_scroll1		;
			; read char line
			;
scroll_address	lda scrolltext
			ldx current_line
			sta current_char
			cmp #$ff
			bne scroll_not_end
			;
			; reset scroll
			;
			lda #<scrolltext
			sta scroll_address+1
			lda #>scrolltext
			sta scroll_address+2
			jmp scroll_address
			;		
scroll_not_end	clc
			rol
			clc
			rol
			clc
			rol
			sta read_char_line+1
			;
			bcs offset_2d
			;
			lda #$1e			; hi byte of scroll font location
			sta read_char_line+2
			jmp read_char_line
			;
offset_2d		lda #$1f			; hi byte of scroll font location
			sta read_char_line+2
			;
read_char_line	lda $1e00,x
			sta $22c7
			;
			inc current_line
			lda current_line
			cmp #$06
			bne char_not_end
			lda #$00
			sta current_line
			;
			; increase scrolltext
			;
			inc scroll_address+1
			lda scroll_address+1
			cmp #$00
			bne char_not_end
			;
			inc scroll_address+2
			;
char_not_end	rts
;-------------------------------

			;
			; do the second scroll
			; aka realtime shrinker ;)
			;
do_scroll2		lda $22c7
			sta scroll1_char
			;
			; bit 7
			;
			lda scroll1_char
			and #$80
			sta shrink_char
			;
			; bit 5
			;
			lda scroll1_char
			and #$20
			clc
			rol
			ora shrink_char
			sta shrink_char
			;
			; bit 3
			;
			lda scroll1_char
			and #$08
			clc
			rol
			clc
			rol
			ora shrink_char
			ora #%00011111
			;
			sta $239f
			rts
;-------------------------------

			;
			; the fadeout
			;
fadeout		ldx fadeout_counter
			lda fadecol_out_d021,x
			sta $d021
			lda fadecol_out_spr,x
			sta $d027
			sta $d028
			sta $d029
			sta $d02a
			;
			inc fadeout_frames
			lda fadeout_frames
			cmp #$02			
			bne fadeout_done
			;			
			inc fadeout_counter
			lda fadeout_counter
			cmp #$09
			bne fadeout_more
			;
			lda #$02
			sta fadeout_flag
			jmp fadeout_done
			;
fadeout_more	lda #$00
			sta fadeout_frames
			;
fadeout_done	rts
			
;-------------------------------
; scroll text
;-------------------------------

			* = $4000

scrolltext		.screen "                "
			.screen "consumed by darkness, controlled by regret.   "
			.screen "lost and alienated, are we beyond any recognition or repair?    " 
			.screen "welcome to echo 17, a freshly conceived intro from arise design.   "
			.screen "concept and creation concluded on 30/11/2013 by wackee.   "
			.screen "this intro is my contribution to intro competition held @ csdb, "
			.screen "but also a tribute to richie hawtin also known as plastikman.   "
			.screen "press space to exit, or stay for a while and enjoy this acid sound.         "
			.screen " -/- arise design 2013. we are good. -/-    "
			.byte $ff

			        ;1234567890123456789012345678901234567890
credits		.screen "- code/msx/gfx/wackee/arisedesign/2013 -"
			.byte $ff

;-------------------------------
; binary includes
;-------------------------------

			* = $1000
			;
			; music
			;
			.binary "1000.plas04.prg",2
		
			* = $2000
			;
			; layout charset
			;
			.binary "2000.layoutcharset.prg",2
						
			* = $2800
			;
			; screen layout
			;
			.binary "2800.screenlayout.prg",2
						
			* = $1e00
			;
			; scroll font
			;
			.binary "2c00.scrollfont.v2.prg",2
			
			; 
			; animation frames
			;
			* = $2c00
			.binary "anim.sc1.prg",2
			
			* = $3000
			.binary "anim.sc2.prg",2
			
			* = $3400
			.binary "anim.sc3.prg",2
			
			* = $3800
			.binary "anim.sc4.prg",2
			
			* = $3c00
			.binary "anim.sc5.prg",2
			
			* = $2400
			;
			; anim charset
			; 
			.binary "anim.chr.fix.prg",2

;-----------------------------
; all ends here.
;-----------------------------